/*
 * Copyright (c) 2015 Ziver
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.page.struct;

import java.util.*;

/**
 * Created by Ziver on 2015-04-02.
 */
public class WANavigation implements Iterable{
    private static int nextId = 0;
    private static HashMap<Integer, WANavigation> navMap = new HashMap<Integer, WANavigation>();
    private static WANavigation rootNav = new WANavigation(null);

    private final int id;
    private String url;
    private String name;
    private WANavigation parentNav;
    private ArrayList<WANavigation> subNav;
    private Object resource;


    private WANavigation(String name) {
        this.id = nextId++;
        this.navMap.put(this.id, this);
        this.url = "?i="+this.id;
        this.name = name;
        this.subNav = new ArrayList<>();
    }


    @Override
    public Iterator iterator() {
        return subNav.iterator();
    }
    public List<WANavigation> getSubNavs() {
        return subNav;
    }
    private WANavigation getSubNav(String name) {
        for(WANavigation nav : subNav) {
            if(nav.equals(name))
                return nav;
        }
        return null;
    }
    /**
     * Will create a new subnav if it does not already exist or return the existing one.
     */
    public WANavigation createSubNav(String name) {
        WANavigation nav = getSubNav(name);
        if(nav != null)
            return nav;

        nav = new WANavigation(name);
        nav.setParentNav(this);
        subNav.add(nav);
        return nav;
    }

    public String getName(){
        return name;
    }
    public String getUrl(){
        return url;
    }
    public Object getResource(){
        return resource;
    }
    public void setResource(Object obj){
        resource = obj;
    }

    private void setParentNav(WANavigation nav){
        this.parentNav = nav;
    }

    @Override
    public boolean equals(Object o){
        if(o instanceof String)
            return this.name.equals(o);
        return this == o ||
                (o != null && this.name.equals(((WANavigation)o).name));
    }


    public static List<WANavigation> getRootNav(){
        return rootNav.getSubNavs();
    }
    public static WANavigation createRootNav(String name){
        return rootNav.createSubNav(name);
    }

    public static List<WANavigation> getNavBreadcrumb(Map<String, String> request) {
        LinkedList list = new LinkedList();
        if(request.containsKey("i")){
            WANavigation current = navMap.get(Integer.parseInt(request.get("i")));
            while(current != null && current != rootNav){
                list.addFirst(current);
                current = current.parentNav;
            }
        }
        return list;
    }
}
